//  20/08/1998 : G.Barrand : creation.
//  05/01/2004 : L.GARNIER. Remove tick logic that had been displaced
//               on the SoAxis class.

#ifndef HEPVis_SbAxis_h
#define HEPVis_SbAxis_h
 
#include <Inventor/SbBasic.h> 

class SbAxis {
 public:
  SbAxis();
  ~SbAxis();
  SbBool setMinimumValue(float);
  SbBool setMaximumValue(float);
  SbBool setLogScale(SbBool);

  float getMinimumValue() const;
  float getMaximumValue() const;
  SbBool isLogScale() const;

  void adjustAxis();
 private:
  float fMinimumValue;
  float fMaximumValue;
  int fNumberOfSteps;
  SbBool fLogScale;
};

#endif
