#ifndef HEPVis_SbRotation_h
#define HEPVis_SbRotation_h 

// Code taken from CoinGL/SbRotation but by using doubles instead of floats.
// It is used by SbPolyhedron::Transform.

#include <Inventor/SbVec4d.h>

class SbVec3d;

namespace HEPVis {

class SbRotation {
public:
  SbRotation();
  SbRotation(const SbVec3d& axis,double radians);
  SbRotation(double a11, double a12,double a13, double a14,
             double a21, double a22,double a23, double a24,
             double a31, double a32,double a33, double a34,
             double a41, double a42,double a43, double a44);
public:
  //SbRotation& operator*=(const double s);
  void multVec(const SbVec3d& src,SbVec3d& dst) const;
private:
  SbVec4d quat;
};

}

#endif
