#ifndef Lib_Parser_h
#define Lib_Parser_h

namespace Lib {

class IResult {
public:
  virtual ~IResult(){}
  virtual void* cast_head() const = 0;
};

class IParser {
public:
  virtual ~IParser(){}
public:
  typedef unsigned int Length;
public:
  virtual bool primary(const char* b,Length l,
                       IResult& res) const = 0;
  virtual bool unary(const char* o,Length lo,
                     const IResult& r,
                     IResult& res) const = 0;
  virtual bool binary(const IResult& l,
                      const char* o,Length lo,
                      const IResult& r,
                      IResult& res) const = 0;
  virtual bool evaluate(const char* b,Length l,IResult& res) const = 0;
  virtual IResult* create_result() const = 0;
};

class BaseParser : public virtual IParser {
public:
  BaseParser(char a_l = '(',char a_r = ')'):m_l_sep(a_l),m_r_sep(a_r){}
  virtual ~BaseParser(){}
public:
  virtual bool evaluate(const char* b,Length l,IResult& res) const;
private:
  char m_l_sep;
  char m_r_sep;
};

}

#endif
