#ifndef Lib_StreamBuffer_h
#define Lib_StreamBuffer_h

// inheritance :
#include <Lib/strstream.h>

#include <stdio.h>

namespace Slash {namespace Core {class IWriter;}}

namespace Lib {

class StreamBuffer 
#ifdef HasAnsiStream
:public std::streambuf 
#else
:public streambuf 
#endif
{
public:
  StreamBuffer(Slash::Core::IWriter&);
  StreamBuffer(const StreamBuffer&);
  virtual ~StreamBuffer();
  StreamBuffer& operator=(const StreamBuffer&);
public:
  int overflow(int = EOF);
  int sync();
#ifdef WIN32
  int underflow();
#endif
  int receiveString();
private:
  Slash::Core::IWriter& fPrinter;
  char* fBuffer;
  unsigned int fSize;
  unsigned int fCount;
};

}
 
#endif
