#ifndef Slash_Tools_Net_h
#define Slash_Tools_Net_h

#include <Slash/Tools/Managers.h>

#include "smanip.h"

namespace Slash {

inline bool get_file(Slash::Core::ISession& aSession,const std::string& aFile){
  Slash::Net::INetManager* netManager = Slash::netManager(aSession);
  if(netManager) {
    if(!netManager->isClient()) { //server ask the file to the client.
      if(!netManager->askFile(aFile)) {
        std::ostream& out = aSession.cout();
        out << "get_file :"
            << " askFile failed."
            << std::endl;
        return false;
      }
      std::string path,name,suffix;
      Slash::path_name_suffix(aFile,path,name,suffix);
      std::string file = name;
      if(!netManager->waitFile(file)) {
        std::ostream& out = aSession.cout();
        out << "get_file :"
            << " waitFile failed."
            << std::endl;
        return false;
      }
    }
  }
  return true;
}

}

#endif
